!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module TimeSet
!
!   * Developer: SUGIYAMA Ko-ichiro (sugiyama@gfd-dennou.org)
!   * Version: $Id: timeset.f90,v 1.2 2005/01/28 12:41:21 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!NAMELIST ֤Ԥ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
!顼ˤ gt4f90io 
!
                                                                 !=end

module timeset
  implicit none
  save
                                                                 !=begin
  !== Public Interface
  real(8)           :: DelTimeLong   !Ĺॹƥå
  real(8)           :: DelTimeShort  !ûॹƥå
  real(8)           :: TimeInt    !ʬ
  integer           :: TimeDisp   !եϤ륹ƥå׿ 
  integer           :: NstepLong !ĹॹƥåפΥƥå׿
  integer           :: NstepShort!ûॹƥåפΥƥå׿
                                                                 !=end  
contains
                                                                 !=begin
  !== Procedure Interface 
  !
  !=== Initialize module and acquire NAMELIST
  !
  !NAMELIST ɬפʾɤ߼, ѿԤ. 
  !
  subroutine timeset_init(cfgfile)

    !=== Input
    character(*), intent(in) :: cfgfile
    
    !=== NAMELIST
    NAMELIST /timeset/ &
         & DelTimeLong, DelTimeShort, TimeInt, TimeDisp
    
    open (10, FILE=cfgfile)
    read(10, NML=timeset)
    close(10)
                                                                 !=end    
    !--- 롼ײ
    NstepLong = TimeInt / DelTimeLong 
    NstepShort = 2 * DelTimeLong / DelTimeShort

    !--- ٹ
    if(mod(TimeInt, DelTimeShort) /= 0) then 
       write(*,*) "mod(TimeInt, DelTimeLong) is not zero"
    end if
    
    if(mod(2 * DelTimeLong, DelTimeShort) /= 0) then 
       write(*,*) "mod(2 * DelTl, DelTimeShort) is not zero"
    end if
    
  end subroutine timeset_init
  
end module timeset
